package fr.uca.iut.clfreville2.teaiswarm

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import androidx.core.os.bundleOf
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.navigation.fragment.NavHostFragment
import fr.uca.iut.clfreville2.teaiswarm.fragment.RepositoryListFragment
import fr.uca.iut.clfreville2.teaiswarm.model.Repository

const val REPOSITORY_OWNER = "repository_owner"
const val REPOSITORY_NAME = "repository_name"

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        supportFragmentManager.fragmentFactory = RepositoryListFragmentFactory { repo ->
            adapterOnClick(repo)
        }
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }

    private fun adapterOnClick(repository: Repository) {
        val bundle =
            bundleOf(
                REPOSITORY_OWNER to repository.owner.login,
                REPOSITORY_NAME to repository.name
            )
        val nav = supportFragmentManager.findFragmentById(R.id.nav_host_fragment) as NavHostFragment
        nav.navController.navigate(R.id.activity_list_fragment, bundle)
    }

    class RepositoryListFragmentFactory(private val onClick: (Repository) -> Unit) : FragmentFactory() {
        override fun instantiate(classLoader: ClassLoader, className: String): Fragment {
            if (className == RepositoryListFragment::class.java.name) {
                return RepositoryListFragment("clement.freville2", onClick);
            }
            return super.instantiate(classLoader, className)
        }
    }
}